package com.glxp.mipsdl.entity.auth;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 管理员表
 */
@Data
@TableName(value = "auth_user")
public class AuthUserEntity {

    private Long id;

    /**
     * 用户名
     */
    @TableField(value = "userName")
    private String userName;

    /**
     * 登录密码；sp_password加密
     */
    @TableField(value = "`passWord`")
    private String passWord;

    /**
     * 最后登录ip
     */
    @TableField(value = "lastLoginIp")
    private String lastLoginIp;

    /**
     * 注册时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 用户状态 0：禁用； 1：正常 ；2：未验证
     */
    @TableField(value = "userFlag")
    private Integer userFlag;

    @TableField(value = "lastModifyTime")
    private Date lastModifyTime;

    @TableField(value = "comments")
    private String comments;

    @TableField(value = "employeeName")
    private String employeeName;

    @TableField(value = "CustomerId")
    private String customerId;

    @TableField(value = "lastLoginTime")
    private Date lastLoginTime;

    /**
     * 当前部门
     */
    @TableField(value = "locDeptCode")
    private String locDeptCode;

    /**
     * 当前仓库
     */
    @TableField(value = "locInvCode")
    private String locInvCode;

    @TableField(exist = false)
    public static final String COL_ID = "id";
}