package com.glxp.mipsdl.entity.basic;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 单据类型表
 */
@Data
@TableName(value = "basic_bussiness_type")
public class BasicBussinessTypeEntity {

    /**
     * id
     */
    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 主类型（出库，入库）
     */
    @TableField(value = "mainAction")
    private String mainAction;

    /**
     * 业务类型
     */
    @TableField(value = "`action`")
    private String action;

    /**
     * 业务名称
     */
    @TableField(value = "`name`")
    private String name;

    /**
     * 是否启用， 0：未启用  1：启用
     */
    @TableField(value = "`enable`")
    private Boolean enable;

    /**
     * 备注
     */
    @TableField(value = "remark")
    private String remark;

    /**
     * 第三方系统外键
     */
    @TableField(value = "thirdSysFk")
    private String thirdSysFk;

    /**
     * 是否自动生成往来单位：1.是；2.否
     */
    @TableField(value = "genUnit")
    private Boolean genUnit;

    /**
     * 是否是内部单据：1.是；0：否
     */
    @TableField(value = "innerOrder")
    private Boolean innerOrder;

    /**
     * 是否二次验收
     */
    @TableField(value = "secCheckEnable")
    private Boolean secCheckEnable;

    /**
     * 是否根据业务单据类型校验
     */
    @TableField(value = "checkEnable")
    private Boolean checkEnable;

    /**
     * UDIMS平台来源是否需要校验
     */
    @TableField(value = "checkUdims")
    private Boolean checkUdims;

    /**
     * pda已校验单据
     */
    @TableField(value = "checkPdaEd")
    private Boolean checkPdaEd;

    /**
     * pda未检验单据
     */
    @TableField(value = "checkPdaUn")
    private Boolean checkPdaUn;

    /**
     * PC端扫码精灵
     */
    @TableField(value = "checkPc")
    private Boolean checkPc;

    /**
     * web前端页面新增单据
     */
    @TableField(value = "checkWebNew")
    private Boolean checkWebNew;

    /**
     * 供应商平台导出单据
     */
    @TableField(value = "checkSp")
    private Boolean checkSp;

    /**
     * 流转生成单据
     */
    @TableField(value = "checkChange")
    private Boolean checkChange;

    /**
     * UDIMS平台单据 二次校验
     */
    @TableField(value = "secCheckUdims")
    private Boolean secCheckUdims;

    /**
     * 手持终端已校验单据 二次校验
     */
    @TableField(value = "secCheckPdaEd")
    private Boolean secCheckPdaEd;

    /**
     * 手持终端未校验单据 二次校验
     */
    @TableField(value = "secCheckPdaUn")
    private Boolean secCheckPdaUn;

    /**
     * UDI扫码通 二次校验
     */
    @TableField(value = "secCheckPc")
    private Boolean secCheckPc;

    /**
     * web端新增单据 二次复核
     */
    @TableField(value = "secCheckWebNew")
    private Boolean secCheckWebNew;

    /**
     * 自动补单二次复核
     */
    @TableField(value = "secCheckChange")
    private Boolean secCheckChange;

    /**
     * 供应商平台导出单据
     */
    @TableField(value = "secCheckSp")
    private Boolean secCheckSp;

    /**
     * 往来单位类型
     */
    @TableField(value = "corpType")
    private Integer corpType;

    /**
     * 补单扫码单据类型
     */
    @TableField(value = "supplementOrderType")
    private String supplementOrderType;

    /**
     * 平衡补单是否校验
     */
    @TableField(value = "checkBalance")
    private Boolean checkBalance;

    /**
     * 平衡补单是否二次验收
     */
    @TableField(value = "secCheckBalance")
    private Boolean secCheckBalance;

    /**
     * 允许科室多次使用出库
     */
    @TableField(value = "useDyCount")
    private Boolean useDyCount;

    /**
     * 到期提示
     */
    @TableField(value = "expireTip")
    private Boolean expireTip;

    /**
     * 更新时间
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 默认往来单位
     */
    @TableField(value = "defaultUnit")
    private String defaultUnit;

    /**
     * 创建单据前缀
     */
    @TableField(value = "`prefix`")
    private String prefix;

    /**
     * 出库是否直接上传至自助平台
     */
    @TableField(value = "outToSpms")
    private Boolean outToSpms;

    /**
     * 允许出库自动缺量补单
     */
    @TableField(value = "ullageFill")
    private Boolean ullageFill;

    /**
     * 是否只采集预验收产品
     */
    @TableField(value = "scanPreIn")
    private Boolean scanPreIn;

    /**
     * 是否访问库存
     */
    @TableField(value = "vailInv")
    private Boolean vailInv;

    /**
     * 允许验收自助平台单据
     */
    @TableField(value = "entrutSpms")
    private Boolean entrutSpms;

    /**
     * 是否强制三期校验
     */
    @TableField(value = "codeFillCheck")
    private Boolean codeFillCheck;

    /**
     * 默认分库
     */
    @TableField(value = "defaultSubInv")
    private Boolean defaultSubInv;

    /**
     * 默认仓库
     */
    @TableField(value = "defaultInv")
    private Boolean defaultInv;

    /**
     * 订单详情展示方式：0：根据批次号展示，1:根据条码展示
     */
    @TableField(value = "orderVisibleType")
    private Boolean orderVisibleType;

    /**
     * 是否校验复制单据
     */
    @TableField(value = "checkCopy")
    private Boolean checkCopy;

    /**
     * 是否二次校验复制单据
     */
    @TableField(value = "secCheckCopy")
    private Boolean secCheckCopy;

    /**
     * 第三方系统单据类型
     */
    @TableField(value = "originAction")
    private String originAction;

    /**
     * 是否预入库
     */
    @TableField(value = "advanceType")
    private Boolean advanceType;

    /**
     * 是否流转
     */
    @TableField(value = "changeEnable")
    private Boolean changeEnable;

    /**
     * 是否供应商使用
     */
    @TableField(value = "spUse")
    private int spUse;
    /**
     * 是否预验收单据类型
     */
    @TableField(value = "preIn")
    private Boolean preIn;

    /**
     * 缺量补单是否全量补单
     */
    @TableField(value = "supplementAll")
    private Boolean supplementAll;

    /**
     * 创建人
     */
    @TableField(value = "`createUser`")
    private String createUser;

    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 更新人
     */
    @TableField(value = "updateUser")
    private String updateUser;

}
