package com.glxp.mipsdl.entity.basic;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
    * 耗材字典表
    */
@Data
@TableName(value = "basic_products")
public class BasicProductsEntity {
    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * UUID
     */
    @TableField(value = "uuid")
    private String uuid;

    /**
     * 同步库原UUID
     */
    @TableField(value = "originUuid")
    private String originUuid;

    /**
     * 最小销售产品标识
     */
    @TableField(value = "nameCode")
    private String nameCode;

    /**
     * 产品记录key（国家库）
     */
    @TableField(value = "deviceRecordKey")
    private String deviceRecordKey;

    /**
     * 包装比例
     */
    @TableField(value = "packRatio")
    private String packRatio;

    /**
     * 包装单位
     */
    @TableField(value = "packUnit")
    private String packUnit;

    /**
     * 包装级别
     */
    @TableField(value = "packLevel")
    private String packLevel;

    /**
     * 包含下级数量
     */
    @TableField(value = "bhxjsl")
    private Integer bhxjsl;

    /**
     * 包含最小销售包装数量
     */
    @TableField(value = "bhzxxsbzsl")
    private Integer bhzxxsbzsl;

    /**
     * 最小包装单元内包含使用单元数量: 
最小销售标识包含使用单元数量
     */
    @TableField(value = "zxxsbzbhsydysl")
    private Integer zxxsbzbhsydysl;

    /**
     * 包含下级产品编码
     */
    @TableField(value = "bhxjcpbm")
    private String bhxjcpbm;

    /**
     * 包装层级
     */
    @TableField(value = "bzcj")
    private String bzcj;

    /**
     * 产品名称，通用名称
     */
    @TableField(value = "cpmctymc")
    private String cpmctymc;

    /**
     * 产品类别
     */
    @TableField(value = "cplb")
    private String cplb;

    /**
     * 分类编码
     */
    @TableField(value = "flbm")
    private String flbm;

    /**
     * 规格型号
     */
    @TableField(value = "ggxh")
    private String ggxh;

    /**
     * 器械类别
     */
    @TableField(value = "qxlb")
    private String qxlb;

    /**
     * 统一社会信用代码证号
     */
    @TableField(value = "tyshxydm")
    private String tyshxydm;

    /**
     * 注册/备案人名称
     */
    @TableField(value = "ylqxzcrbarmc")
    private String ylqxzcrbarmc;

    /**
     * "注册/备案证号，
     */
    @TableField(value = "zczbhhzbapzbh")
    private String zczbhhzbapzbh;

    /**
     * 注册/备案人名称英文名称
     */
    @TableField(value = "ylqxzcrbarywmc")
    private String ylqxzcrbarywmc;

    /**
     * 使用单元产品标识
     */
    @TableField(value = "sydycpbs")
    private String sydycpbs;

    /**
     * 上级产品标识
     */
    @TableField(value = "sjcpbm")
    private String sjcpbm;

    /**
     * 历史版本号，最高为最新
     */
    @TableField(value = "versionNumber")
    private Integer versionNumber;

    /**
     * 表示类型：1.主标识，2，使用单元标识，3.本体标识，4，包装标识
     */
    @TableField(value = "diType")
    private Integer diType;

    /**
     * 医保编码
     */
    @TableField(value = "ybbm")
    private String ybbm;

    /**
     * 商品条码
     */
    @TableField(value = "sptm")
    private String sptm;

    /**
     * 生产厂家
     */
    @TableField(value = "manufactory")
    private String manufactory;

    /**
     * 计量单位
     */
    @TableField(value = "measname")
    private String measname;

    /**
     * 0:UDI，1：第三方产品编码
     */
    @TableField(value = "productType")
    private Integer productType;

    /**
     * 是否包含批号
     */
    @TableField(value = "scbssfbhph")
    private String scbssfbhph;

    /**
     * 是否包含序列号
     */
    @TableField(value = "scbssfbhxlh")
    private String scbssfbhxlh;

    /**
     * 是否包含生产日期
     */
    @TableField(value = "scbssfbhscrq")
    private String scbssfbhscrq;

    /**
     * 是否包含失效日期
     */
    @TableField(value = "scbssfbhsxrq")
    private String scbssfbhsxrq;

    /**
     * 产品描述
     */
    @TableField(value = "cpms")
    private String cpms;

    /**
     * 是否允许无批次号扫码
     */
    @TableField(value = "allowNoBatch")
    private Boolean allowNoBatch;

    /**
     * 是否允许无生产日期扫码
     */
    @TableField(value = "allowNoExpire")
    private Boolean allowNoExpire;

    /**
     * 是否允许无失效日期扫码
     */
    @TableField(value = "allowNoProduct")
    private Boolean allowNoProduct;

    /**
     * 商品名称
     */
    @TableField(value = "spmc")
    private String spmc;

    /**
     * 产品类型（器械类别）
     */
    @TableField(value = "cplx")
    private String cplx;

    /**
     * 耗材或者设备（产品类别）
     */
    @TableField(value = "hchzsb")
    private String hchzsb;

    /**
     * 代理商
     */
    @TableField(value = "cpdls")
    private String cpdls;

    /**
     * 价格
     */
    @TableField(value = "price")
    private Long price;

    /**
     * 备注字段1
     */
    @TableField(value = "basicPrductRemak1")
    private String basicPrductRemak1;

    /**
     * 备注字段2
     */
    @TableField(value = "basicPrductRemak2")
    private String basicPrductRemak2;

    /**
     * 备注字段3
     */
    @TableField(value = "basicPrductRemak3")
    private String basicPrductRemak3;

    /**
     * 备注字段4
     */
    @TableField(value = "basicPrductRemak4")
    private String basicPrductRemak4;

    /**
     * 备注字段5
     */
    @TableField(value = "basicPrductRemak5")
    private String basicPrductRemak5;

    /**
     * 备注字段6
     */
    @TableField(value = "basicPrductRemak6")
    private String basicPrductRemak6;

    /**
     * 备注字段7
     */
    @TableField(value = "basicPrductRemak7")
    private String basicPrductRemak7;

    /**
     * 备注字段8
     */
    @TableField(value = "basicPrductRemak8")
    private String basicPrductRemak8;

    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 最後更新時間
     */
    @TableField(value = "updateTime")
    private String updateTime;

    /**
     * 创建人
     */
    @TableField(value = "`createUser`")
    private String createUser;

    /**
     * 更新人
     */
    @TableField(value = "updateUser")
    private String updateUser;

    @TableField(value = "remark")
    private String remark;

}