package com.glxp.mipsdl.entity.basic;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "basic_sk_project")
public class BasicSkProjectEntity {
    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 自定义编码
     */
    @TableField(value = "idCode")
    private String idCode;

    /**
     * 项目编码
     */
    @TableField(value = "code")
    private String code;

    /**
     * 项目名称
     */
    @TableField(value = "`name`")
    private String name;

    /**
     * 类别
     */
    @TableField(value = "category")
    private String category;

    /**
     * 规格
     */
    @TableField(value = "ggxh")
    private String ggxh;

    /**
     * 备注
     */
    @TableField(value = "remark")
    private String remark;

    @TableField(value = "createTime")
    private Date createTime;

    @TableField(value = "`createUser`")
    private String createUser;

    @TableField(value = "updateTime")
    private Date updateTime;

    @TableField(value = "updateUser")
    private String updateUser;
    /**
     * 类型：1：定数包，内部使用；2：项目、组套外部关联
     */
    @TableField(value = "type")
    private Integer type;


    @TableField(value = "unit")
    private String unit;
    @TableField(value = "price")
    private String price;

    @TableField(value = "status")
    private Integer status;

}
