package com.glxp.mipsdl.entity.inout;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 单据正式码表
 */
@Data
@TableName(value = "io_code")
public class IoCodeEntity {

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * UDI码
     */
    @TableField(value = "code")
    private String code;

    @TableField(value = "errUdiCode")
    private String errUdiCode;

    /**
     * 主单据类型（入库，出库）
     */
    @TableField(value = "mainAction")
    private String mainAction;

    /**
     * 单据类型
     */
    @TableField(value = "`action`")
    private String action;

    /**
     * 订单号外键
     */
    @TableField(value = "orderId")
    private String orderId;

    /**
     * 手持终端订单号
     */
    @TableField(value = "corpOrderId")
    private String corpOrderId;

    /**
     * DI标识
     */
    @TableField(value = "nameCode")
    private String nameCode;

    /**
     * 批次号
     */
    @TableField(value = "batchNo")
    private String batchNo;

    /**
     * 生产日期
     */
    @TableField(value = "produceDate")
    private String produceDate;

    /**
     * 失效日期
     */
    @TableField(value = "expireDate")
    private String expireDate;

    /**
     * 序列号
     */
    @TableField(value = "serialNo")
    private String serialNo;

    /**
     * 包装级别
     */
    @TableField(value = "packageLevel")
    private String packageLevel;

    /**
     * 供应商ID外键
     */
    @TableField(value = "supId")
    private String supId;

    /**
     * 耗材字典ID外键
     */
    @TableField(value = "relId")
    private Long relId;

    /**
     * 扫码数量
     */
    @TableField(value = "`count`")
    private Integer count;

    /**
     * 实际数量
     */
    @TableField(value = "reCount")
    private Integer reCount;

    /**
     * 部门编码外键
     */
    @TableField(value = "deptCode")
    private String deptCode;

    /**
     * 仓库编码外键
     */
    @TableField(value = "invCode")
    private String invCode;

    /**
     * 货位编码外键
     */
    @TableField(value = "warehouseCode")
    private String warehouseCode;

    /**
     * 更新日期
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 创建日期
     */
    @TableField(value = "createTime")
    private Date createTime;

}
