package com.glxp.mipsdl.entity.inout;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

/**
 * 采集点单据详情
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "io_collect_order_biz")
public class IoCollectOrderBiz implements Serializable {
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;
    /**
     * 单据号外键
     */
    @TableField(value = "orderIdFk")
    private String orderIdFk;


    /**
     * 耗材字典ID
     */
    @TableField(value = "relId")
    private Long relId;


    /**
     * 院内编码（第三方编码）
     */
    @TableField(value = "thrCode")
    private String thrCode;

    /**
     * 医保编码
     */
    @TableField(value = "ybbm")
    private String ybbm;

    /**
     * 收费编码
     */
    @TableField(value = "payFeeCode")
    private String payFeeCode;

    /**
     * 产品通用名称
     */
    @TableField(value = "cpmctymc")
    private String cpmctymc;

    /**
     * 产品标识
     */
    @TableField(value = "nameCode")
    private String nameCode;

    /**
     * 规格型号
     */
    @TableField(value = "ggxh")
    private String ggxh;

    /**
     * 批次号
     */
    @TableField(value = "batchNo")
    private String batchNo;

    /**
     * 生产日期
     */
    @TableField(value = "productDate")
    private String productDate;

    /**
     * 失效日期
     */
    @TableField(value = "expireDate")
    private String expireDate;

    /**
     * 单据数量
     */
    @TableField(value = "`count`")
    private Integer count;

    /**
     * 实际数量
     */
    @TableField(value = "actCount")
    private Integer actCount;

    /**
     * 扫码数量
     */
    @TableField(value = "scanCount")
    private Integer scanCount;

    /**
     * 扫码实际数量
     */
    @TableField(value = "scanActCount")
    private Integer scanActCount;

    /**
     * 计量单位
     */
    @TableField(value = "measureUnit")
    private String measureUnit;

    /**
     * 单据明细赋码状态  1:未赋码；2：部分赋码；3：已赋码
     */
    @TableField(value = "tagStatus")
    private Integer tagStatus;

    /**
     * 赋码错误信息
     */
    @TableField(value = "tagMsg")
    private String tagMsg;

    /**
     * 备注
     */
    @TableField(value = "remark")
    private String remark;

    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 更新时间
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 未拆零数量
     */
    @TableField(value = "unTagCount")
    private Integer unTagCount;


    /**
     * 自动扫描分配的工位存量 锁数量
     */
    @TableField(value = "autoResCount")
    private Integer autoResCount;

    /**
     * 上传替换码
     */
    @TableField(value = "replaceCode")
    private String replaceCode;

    /**
     * 自动赋码状态：1：无法自动赋码；2：可以自动赋码；3:可以自动赋码，但是数量不足
     */
    @TableField(value = "autoTagStatus")
    private Integer autoTagStatus;

    @TableField(value = "remark1")
    private String remark1;
    @TableField(value = "remark2")
    private String remark2;
    @TableField(value = "remark3")
    private String remark3;
    @TableField(value = "remark4")
    private String remark4;
    @TableField(value = "remark5")
    private String remark5;
    @TableField(value = "remark6")
    private String remark6;
    @TableField(value = "remark7")
    private String remark7;
    @TableField(value = "remark8")
    private String remark8;
    @TableField(value = "remark9")
    private String remark9;
    @TableField(value = "remark10")
    private String remark10;


    private static final long serialVersionUID = 1L;
}
