package com.glxp.mipsdl.entity.inout;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

/**
 * 采集点单据手动赋码
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "io_collect_order_code_man")
public class IoCollectOrderCodeMan implements Serializable {
    @TableId(value = "id", type = IdType.INPUT)
    private Integer id;

    @TableField(value = "orderIdFk")
    private String orderIdFk;


    /**
     * 绑定业务表ID
     */
    @TableField(value = "bizIdFk")
    private Long bizIdFk;

    @TableField(value = "udiCode")
    private String udiCode;

    @TableField(value = "relId")
    private Long relId;

    @TableField(value = "nameCode")
    private String nameCode;


    @TableField(value = "productDate")
    private String productDate;
    @TableField(value = "expireDate")
    private String expireDate;
    @TableField(value = "batchNo")
    private String batchNo;
    @TableField(value = "serialNo")
    private String serialNo;

    @TableField(value = "scanCount")
    private Integer scanCount;


    @TableField(value = "scanActCount")
    private Integer scanActCount;


    @TableField(value = "remark")
    private String remark;

    @TableField(value = "createTime")
    private Date createTime;

    @TableField(value = "`createUser`")
    private Long createUser;

    @TableField(value = "updateTime")
    private Date updateTime;

    @TableField(value = "updateUser")
    private Long updateUser;

    @TableField(value = "isSplitCode")
    private Boolean isSplitCode;

    @TableField(exist = false)
    private Boolean removeFlag;

    @TableField(exist = false)
    private Boolean splitFlag;
    @TableField(exist = false)
    private Integer remainCount;

    /**
     * 父级编码
     */
    @TableField(value = "parentCode")
    private String parentCode;


    /**
     * 爷级编码
     */
    @TableField(value = "grantPaCode")
    private String grantPaCode;

    private static final long serialVersionUID = 1L;
}
