package com.glxp.mipsdl.entity.inout;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 单据业务详情表
 */
@Data
@TableName(value = "io_order_detail_biz")
public class IoOrderDetailBizEntity {
    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 订单号外键
     */
    @TableField(value = "orderIdFk")
    private String orderIdFk;

    /**
     * 耗材字典ID外键
     */
    @TableField(value = "bindRlFk")
    private String bindRlFk;

    /**
     * DI信息UUID外键
     */
    @TableField(value = "uuidFk")
    private String uuidFk;

    /**
     * DI
     */
    @TableField(value = "nameCode")
    private String nameCode;

    /**
     * 批次号
     */
    @TableField(value = "batchNo")
    private String batchNo;

    /**
     * 生产日期
     */
    @TableField(value = "productDate")
    private String productDate;

    /**
     * 失效日期
     */
    @TableField(value = "expireDate")
    private String expireDate;

    /**
     * 产品通用名称
     */
    @TableField(value = "coName")
    private String coName;

    /**
     * 注册证号
     */
    @TableField(value = "certCode")
    private String certCode;

    /**
     * 医疗器械注册备案证号
     */
    @TableField(value = "ylqxzcrbarmc")
    private String ylqxzcrbarmc;

    /**
     * 生产企业
     */
    @TableField(value = "manufacturer")
    private String manufacturer;

    /**
     * 计量单位
     */
    @TableField(value = "measname")
    private String measname;

    /**
     * 规格型号
     */
    @TableField(value = "spec")
    private String spec;

    /**
     * 价格
     */
    @TableField(value = "price")
    private BigDecimal price;

    /**
     * 销售清单号
     */
    @TableField(value = "secSalesListNo")
    private String secSalesListNo;

    /**
     * 发票第一票
     */
    @TableField(value = "firstSalesInvNo")
    private String firstSalesInvNo;

    /**
     * 发票第二票
     */
    @TableField(value = "secSalesInvNo")
    private String secSalesInvNo;

    /**
     * 发票有效期
     */
    @TableField(value = "invoiceDate")
    private String invoiceDate;

    /**
     * 供应商ID外键
     */
    @TableField(value = "supId")
    private String supId;

    /**
     * 绑定供应商状态
     */
    @TableField(value = "bindSupStatus")
    private String bindSupStatus;

    /**
     * 单据数量
     */
    @TableField(value = "`count`")
    private Integer count;

    /**
     * 单据实际数量
     */
    @TableField(value = "reCount")
    private Integer reCount;

    /**
     * 备注
     */
    @TableField(value = "remark")
    private String remark;

    /**
     * 扩展字段1
     */
    @TableField(value = "remark1")
    private String remark1;

    /**
     * 扩展字段2
     */
    @TableField(value = "remark2")
    private String remark2;

    /**
     * 扩展字段3
     */
    @TableField(value = "remark3")
    private String remark3;

    /**
     * 扩展字段4
     */
    @TableField(value = "remark4")
    private String remark4;

    /**
     * 扩展字段5
     */
    @TableField(value = "remark5")
    private String remark5;

    @TableField(exist = false)
    private String serialNo;

}
