package com.glxp.mipsdl.entity.inout;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;
import java.util.List;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "io_order_invoice")
public class IoOrderInvoiceEntity extends Model<IoOrderInvoiceEntity> {
    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 订单号外键
     */
    @TableField(value = "orderIdFk")
    private String orderIdFk;

    /**
     * 机器编码
     */
    @TableField(value = "machineNo")
    private String machineNo;

    /**
     * 发票代码
     */
    @TableField(value = "invoiceCode")
    private String invoiceCode;

    /**
     * 发票编码
     */
    @TableField(value = "invoiceEncode")
    private String invoiceEncode;

    /**
     * 开票日期
     */
    @TableField(value = "invoiceDate")
    private Date invoiceDate;

    /**
     * 发票价格
     */
    @TableField(value = "price")
    private String price;

    /**
     * 更新是日期
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 更新时间
     */
    @TableField(value = "`createUser`")
    private String createUser;

    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 更新人
     */
    @TableField(value = "updateUser")
    private String updateUser;

    @TableField(value = "bindRlFk")
    private String bindRlFk;

    /**
     * 批次号
     */
    @TableField(value = "batchNo")
    private String batchNo;

    /**
     * 生产日期
     */
    @TableField(value = "productDate")
    private String productDate;

    /**
     * 失效日期
     */
    @TableField(value = "expireDate")
    private String expireDate;

    @TableField(value = "licenseUrl")
    private String licenseUrl;


    @TableField(value = "remark")
    private String remark;

    @TableField(value = "bizIdFk")
    private Long bizIdFk;

    @TableField(exist = false)
    private Integer  regId;


    @TableField(exist = false)
    private List<IoOrderDetailBizEntity> list;

}
