package com.glxp.mipsdl.entity.inout;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
    * 单据上传日志表
    */
@Data
@TableName(value = "io_order_upload_log")
public class IoOrderUploadLogEntity {
    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 单据号
     */
    @TableField(value = "billNo")
    private String billNo;

    /**
     * 单据日期
     */
    @TableField(value = "billDate")
    private Date billDate;

    /**
     * 单据类型
     */
    @TableField(value = "billType")
    private String billType;

    /**
     * 第三方单据号
     */
    @TableField(value = "thrBillNo")
    private String thrBillNo;

    /**
     * 提交时间
     */
    @TableField(value = "submitTime")
    private Date submitTime;

    /**
     * 提交状态 0：未提交 1：正在处理 2：已提交；3：提交失败,4.本身数据错误
     */
    @TableField(value = "`status`")
    private Integer status;

    /**
     * 结果信息
     */
    @TableField(value = "`result`")
    private String result;

    /**
     * 单据来源：1:主动上传到第三方；2.被动接收第三方上传
     */
    @TableField(value = "fromType")
    private Integer fromType;
}
