package com.glxp.mipsdl.entity.njxyy;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 往来单位字典表
 */
@Data
@TableName(value = "basic_corp")
public class BasicCorpEntity {

    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 往来单位编码
     */
    @TableField(value = "erpId")
    private String erpId;

    /**
     * 往来单位名称
     */
    @TableField(value = "`name`")
    private String name;

    /**
     * 往来单位简称
     */
    @TableField(value = "spell")
    private String spell;

    /**
     * 地址
     */
    @TableField(value = "addr")
    private String addr;

    /**
     * 状态
     */
    @TableField(value = "`status`")
    private Integer status;

    /**
     * 类型
     */
    @TableField(value = "`type`")
    private String type;

    /**
     * 联系人
     */
    @TableField(value = "contact")
    private String contact;

    /**
     * 联系电话
     */
    @TableField(value = "mobile")
    private String mobile;

    @TableField(value = "creditNo")
    private String creditNo;

    /**
     * 第三方平台ID（备用）
     */
    @TableField(value = "thirdId")
    private String thirdId;

    @TableField(value = "thirdId1")
    private String thirdId1;

    @TableField(value = "thirdId2")
    private String thirdId2;

    @TableField(value = "thirdId3")
    private String thirdId3;

    @TableField(value = "thirdId4")
    private String thirdId4;

    @TableField(value = "thirdName")
    private String thirdName;

    @TableField(value = "thirdName1")
    private String thirdName1;

    @TableField(value = "thirdName2")
    private String thirdName2;

    @TableField(value = "thirdName3")
    private String thirdName3;

    @TableField(value = "thirdName4")
    private String thirdName4;

    /**
     * 往来单位类型：1.客户，2：供应商，3：内部科室,4.特殊往来;5.生产厂家
     */
    @TableField(value = "corpType")
    private Integer corpType;

    /**
     * 客户单据：1.患者，2.客户
     */
    @TableField(value = "outType")
    private Integer outType;

    /**
     * 创建人
     */
    @TableField(value = "`createUser`")
    private String createUser;

    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 更新人
     */
    @TableField(value = "updateUser")
    private String updateUser;

    /**
     * 更新时间
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 备注
     */
    @TableField(value = "remark")
    private String remark;
}
