package com.glxp.mipsdl.entity.system;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 第三方接口服务日志表
 */
@Data
@TableName(value = "sys_erp_log")
public class SysErpLogEntity {

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 请求路径
     */
    @TableField(value = "url")
    private String url;

    /**
     * 接口名/方法名
     */
    @TableField(value = "`name`")
    private String name;

    /**
     * 入参
     */
    @TableField(value = "params")
    private String params;

    /**
     * 结果
     */
    @TableField(value = "`result`")
    private String result;

    /**
     * 请求时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 操作类型 interface:：接口  third：请求第三方系统
     */
    @TableField(value = "`type`")
    private String type;

    /**
     * 处理状态
     */
    @TableField(value = "`status`")
    private Integer status;

    /**
     * 处理时长
     */
    @TableField(value = "time")
    private Long time;
}