package com.glxp.mipsdl.entity.thrsys;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
@TableName(value = "thr_order_upload_bustypes", autoResultMap = true)
public class ThrOrderUploadBustypesEntity implements Serializable {

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField(value = "`action`")
    private String action;

    @TableField(value = "`name`")
    private String name;

    /**
     * 单据类型状态:  1:未审核;2:已审核;3:已确认
     */
    @TableField(value = "orderStatus")
    private Integer orderStatus;

    /**
     * 单据来源(数组)
     */
    @TableField(value = "orderSource", typeHandler = JacksonTypeHandler.class)
    private List<String> orderSource;

    /**
     * 创建人
     */
    @TableField(value = "`createUser`")
    private String createUser;

    /**
     * 单据上传起始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @TableField(value = "`orderStartTime`")
    private Date orderStartTime;


    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 更新人
     */
    @TableField(value = "updateUser")
    private String updateUser;

    /**
     * 更新时间
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 备注
     */
    @TableField(value = "remark")
    private String remark;

    private static final long serialVersionUID = 1L;
}
