package com.glxp.mipsdl.entity.thrsys;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;

import java.util.Date;

@Data
@TableName(value = "thr_products")
public class ThrProductsEntity extends Model<ThrProductsEntity> {

    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 产品编码
     */
    private String code;

    /**
     * 通用名称
     */
    private String name;

    /**
     * 计量单位
     */
    private String measname;

    private String spec;

    /**
     * 注册证号
     */
    @TableField("registerNo")
    private String registerNo;

    /**
     * 生产厂家
     */
    private String manufactory;

    @TableField("thirdSysFk")
    private String thirdSysFk;

    /**
     * 产品类别
     */
    private String cplb;

    /**
     * 分类编码
     */
    private String flbm;

    /**
     * 器械类别
     */
    private String qxlb;

    /**
     * 医保编码
     */
    private String ybbm;

    /**
     * 商品条码
     */
    private String sptm;

    /**
     * 注册人社会信用号
     */
    private String tyshxydm;

    /**
     * 注册证 备案证号
     */
    private String zczbhhzbapzbh;

    /**
     * 注册/备案人名称
     */
    private String ylqxzcrbarmc;

    /**
     * 注册/备案人英文名称
     */
    private String ylqxzcrbarywmc;

    /**
     * 产品描述
     */
    private String cpms;

    /**
     * 更新时间
     */
    @TableField("updateTime")
    private Date updateTime;

    /**
     * 供应商名称
     */
    @TableField("supName")
    private String supName;

    /**
     * 型号
     */
    private String model;

    /**
     * 规格型号（规格型号二合一字段）
     */
    private String standard;

    /**
     * 其他编码
     */
    private String qtbm;

    /**
     * 注册证有效期截止时间
     */
    private String zczyxqz;

    /**
     * 备注 备注字段暂未启用，为保留字段
     */
    private String remark;

    /**
     * 备注1
     */
    private String remark1;

    /**
     * 备注2
     */
    private String remark2;

    /**
     * 备注3
     */
    private String remark3;

    /**
     * 价格
     */
    private String price;

    /**
     * 创建人
     */
    @TableField("createUser")
    private String createUser;

    /**
     * 创建时间
     */
    @TableField("createTime")
    private Date createTime;

    /**
     * 更新人
     */
    @TableField("updateUser")
    private String updateUser;

    /**
     * 生产厂家编码
     */
    @TableField("manufactoryCode")
    private String manufactoryCode;

    /**
     * 配送企业编码
     */
    @TableField("supCode")
    private String supCode;

    @TableField("type")
    private Integer type;

    @TableField(exist = false)
    private String createByName;

    /**
     * 处方项目字典
     */
    @TableField("prcitmcode")
    private String prcitmcode;

    @TableField("productType")
    private Integer productType;
    /**
     * 制剂规格
     */
    @TableField(value = "prepnSpec")
    private String prepnSpec;

    /**
     * 制剂规格
     */
    @TableField(value = "prepnUnit")
    private String prepnUnit;

}
