package com.glxp.mipsdl.req.base;

import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 库存产品接口请求参数
 */
@Data
public class UdiwmsInvProductsRequest extends ListPageRequest {

    /**
     * 批次号
     */
    private String batchNo;

    /**
     * 货位号，支持模糊查询
     */
    private String warehouseCode;

    /**
     * 货位名称，支持模糊查询
     */
    private String warehouseName;

    /**
     * 仓库号，支持模糊查询
     */
    private String inventoryCode;

    /**
     * 仓库名称，支持模糊查询
     */
    private String inventoryName;

    /**
     * 仓库编码集合，暂不启用
     */
    private List<String> inventoryCodes;

    /**
     * 产品编号，支持模糊查询
     */
    private String productId;

    /**
     * 产品名称
     */
    private String productName;

    /**
     * 供应商名称（配送企业），支持模糊查询
     */
    private String supName;

    /**
     * 生产厂家
     */
    private String manufactory;

    /**
     * 规格型号，支持模糊查询
     */
    private String standard;

    /**
     * 注册/备案证号，支持模糊查询
     */
    private String registerNo;


    /**
     * 产品名称
     */
    private String cpmctymc;

    /**
     * 产品标识DI
     */
    private String nameCode;

    /**
     * UDI码
     */
    private String udiCode;

    /**
     * 耗材字典ID
     */
    private String relIdFk;

    /**
     * 规格型号
     */
    private String ggxh;


    /**
     * 生产日期
     */
    private String productionDate;

    /**
     * 失效日期
     */
    private String expireDate;

    /**
     * 生产厂家
     */
    private String ylqxzcrbarmc;

    /**
     * 批准文号
     */
    private String zczbhhzbapzbh;

    /**
     * 客户ID
     */
    private String customerId;

    /**
     * 供应商ID
     */
    private String supId;


    /**
     * 部门编码
     */
    private String deptCode;

    /**
     * 仓库编码
     */
    private String invCode;

    /**
     * 仓库数组
     */
    private List<String> invCodes;

    /**
     * 产品类别
     */
    private String cplb;

    /**
     * 货位号
     */
    private String invSpaceCode;

    /**
     * 是否过滤0库存
     */
    private Integer filterCount;

    private String code;

    private String serialNo;


    private String diCode;

    private String basicPrductRemak1;
    private String category;
    private Integer filterNoInv;

    private Date startDate;
    private Date endDate;
    private String thirdSys;

}
