package com.glxp.mipsdl.req.base;

import com.glxp.mipsdl.constant.Constants;
import lombok.Data;

/**
 * 产品信息查询接口参数
 */
@Data
public class UdiwmsProductRequest extends ListPageRequest {

    /**
     * 产品编码
     */
    private String code;

    /**
     * 产品名称
     */
    private String name;

    /**
     * 注册/备案号
     */
    private String registerNo;

    /**
     * 生产厂家
     */
    private String manufactory;

    /**
     * 医保编码
     */
    private String ybbm;

    /**
     * 规格型号
     */
    private String standard;

    /**
     * 最后更新时间
     */
    private String lastUpdateTime;

    /**
     * 备注
     */
    private String remark;

    /**
     * 备注1
     */
    private String remark1;

    /**
     * 备注2
     */
    private String remark2;

    /**
     * 备注3
     */
    private String remark3;

    /**
     * 产品类型 器械 1  药品 2
     */
    private Integer productType;

    /**
     * 为空默认 器械 1
     * @return
     */
    public Integer getProductType() {
        if(productType == null){
            return Constants.PRODUCT_TYPE_DEVICE;
        }
        return productType;
    }

}
