package com.glxp.mipsdl.req.base.forthird;

import com.glxp.mipsdl.req.base.ListPageRequest;
import lombok.Data;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;

@Data
public class ForInvProductsFilter {

    /**
     * UDI码（主码+次码） 01069412732363351123050210D230262121D23026201181
     */
    private String udiCode;

    /**
     * DI主标识 06941273236335
     */
    private String nameCode;

    /**
     * 产品名称 可吸收免打结外科缝线
     */
    private String cpmctymc;

    /**
     * 批次号 202006
     */
    private String batchNo;

    /**
     * 仓库/科室编码 1001
     */
    private String invCode;

    /**
     * 配送商名称 片仔癀诊断
     */
    private String supName;

    /**
     * 收费项目编码
     */
    private String xmbm;


    /**
     * 页码
     */
    @Min(message = "分页参数错误", value = 1)
    private Integer page;

    /**
     * 条数
     */
    @Min(value = 1, message = "分页参数不能小于1")
    @Max(value = 500, message = "分页参数不能大于500")
    private Integer limit;
    /**
     * 耗材字典ID
     */
    private String relIdFk;

}
