package com.glxp.mipsdl.req.ptxhyy;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

/**
 * 平潭协和医院
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class PtxhyyOrderRequest {

    /**
     * 库房序号
     */
    private String kfxh;

    /**
     * 账簿类别 default:1
     */
    private final Integer zblb = 1;

    /**
     * 入库单号
     */
    private String lzdh;

    /**
     * 操作工号
     */
    private String czgh;

    /**
     * 入库方式
     */
    private String lzfs;

    /**
     * 单位序号
     */
    private String dwxh;

    /**
     * 入库日期
     */
    private String rkrq;

    /**
     * 单据金额
     */
    private BigDecimal djje;

    /**
     * 是否开发票 0否 1是
     */
    private int fpbz;

    /**
     * 制单日期
     */
    private String zdrq;

    /**
     * 零售金额
     */
    private BigDecimal lsje;

    /**
     * 发票张数
     */
    private Integer fpzs;

    /**
     * UDI的单据唯一标识码
     */
    private String udixh;


    private List<PtxhyyOrderDetailRequest> detailList;
}
