package com.glxp.mipsdl.req.yb;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 商品库存变更
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Kcbg3502Request {

    /**
     * 医疗目录编码
     */
    private String med_list_codg;
    /**
     * 库存变更类型
     */
    private String inv_chg_type;
    /**
     * 定点医药机构目录编号
     */
    private String fixmedins_hilist_id;
    /**
     * 定点医药机构目录名称
     */
    private String fixmedins_hilist_name;
    /**
     * 定点医药机构批次流水号
     */
    private String fixmedins_bchno;
    /**
     * 单价
     */
    private String pric;
    /**
     * 数量
     */
    private Integer cnt;
    /**
     * 处方药标志
     */
    private String rx_flag;
    /**
     * 库存变更时间
     */
    private Date inv_chg_time;
    /**
     * 库存变更经办人姓名
     */
    private String inv_chg_opter_name;
    /**
     * 备注
     */
    private String memo;
    /**
     * 拆零标志
     */
    private String trdn_flag;
    /**
     * 溯源码节点信息
     */
//    private String drugtracinfo;


    /**
     * 溯源码节点信息
     */
    private List<DrugInfoRequest> drugtracinfo;

    /**
     * 药品追溯码
     */
    private String drug_trac_codg;
}
