package com.glxp.mipsdl.req.yb;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;
import java.util.List;

/**
 * 商品盘存上传
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Pcsc3501Request {

    /**
     * 医疗目录编码
     */
    private String med_list_codg;
    /**
     * 定点医药机构目录编号
     */
    private String fixmedins_hilist_id;
    /**
     * 定点医药机构目录名称
     */
    private String fixmedins_hilist_name;
    /**
     * 处方药标志
     */
    private String rx_flag;
    /**
     * 盘存日期
     */
    private Date invdate;
    /**
     * 库存数量
     */
    private Integer inv_cnt;
    /**
     * 生产批号
     */
    private String manu_lotnum;
    /**
     * 定点医药机构批次流水号
     */
    private String fixmedins_bchno;
    /**
     * 生产日期
     */
    private String manu_date;
    /**
     * 有效期止
     */
    private String expy_end;
    /**
     * 备注
     */
    private String memo;
//    /**
//     * 溯源码节点信息
//     */
//    private String drugtracinfo;

    /**
     * 溯源码节点信息
     */
    private List<DrugInfoRequest> drugtracinfo;

    /**
     * 药品追溯码
     */
    private String drug_trac_codg;

}
