package com.glxp.mipsdl.res.udiwms;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class BasicSkSickerResponse {

    private String sickerId;

    /**
     * 患者编码
     */
    private String code;

    /**
     * 姓名
     */
    private String name;

    /**
     * 住院号
     */
    private String adNum;

    /**
     * 身份证号
     */
    private String idNum;

    /**
     * 手机号
     */
    private String phone;

    /**
     * 性别
     */
    private String gender;

    /**
     * 职业
     */
    private String job;

    /**
     * 出生年月
     */
    private String bornDate;

    /**
     * 国籍
     */
    private String nationality;

    /**
     * 文化程度
     */
    private String education;

    /**
     * 监护人
     */
    private String guardianName;

    /**
     * 监护人与患者关系
     */
    private String guardianRel;

    /**
     * 现居住地
     */
    private String curAddr;

    /**
     * 户籍地
     */
    private String kosekiAddr;

    /**
     * 医保
     */
    private String medicalIns;

    /**
     * 创建人
     */
    private String createUser;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新人
     */
    private String updateUser;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 备注
     */
    private String remark;

    /**
     * 入院时间
     */
    private Date inHospTime;

    /**
     * 出院时间
     */
    private Date outHospTime;
}

