package com.glxp.mipsdl.res.udiwms;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

@Data
public class UdiwmsOrderResponse {
    private Integer id;
    private String billNo;
    private String billdate;
    private String corpId;
    private String corpName;
    private String billType;
    private String billFlag;
    @JsonIgnore
    private String signFlag;
    @JsonIgnore
    private String originType;
    private String invCode;
    private String fromInvCode;  //往来仓库
    private String thirdSysFk;
    private List<UdiwmsOrderResponse.SubErpOrder> subErpOrders;

    //增加字段
    private String startDate; //起始日期
    private String endDate; //结束日期
    private String createUser; //创建人
    private String reviewUser; //审核人
    private String address; //地址
    private String linkMan; //联系人
    private String linkTel; //联系电话
    private String remark; //备注
    private String remark1; //备注1
    private String remark2; //备注2
    private String remark3; //备注3
    private String invWarehouseName;
    private String fromSubInvName;
    private String billTypeName;
    private String confirmUser;

    @Data
    public static class SubErpOrder {
        private Integer id;
        private String productId;
        private String productName;
        private String spec;
        private String batchNo;
        private String expireDate;
        private String productDate;
        private int count;  //账面数量
        private int reCount;    //实际数量
        private String orderIdFk;
        private String thirdSysFk;
        private String sweepCount;
        private String relId;       //基础信息关联表主键
        private String detailId; //明细ID
        private String corpName; //往来单位
        private BigDecimal price; //单价

    }


}
